{$X+}

unit Pol;

interface

const MaxHash = 43;

type

  PPol = ^TPol;
  TPol = object

           Pol : pointer;

           constructor Init;
           destructor  Done;virtual;
           procedure   Reset;virtual;

           procedure InitSetStr;virtual;
           procedure InitGetStr;virtual;
           procedure SetStr(s:PPol);virtual;
           function  GetStr:string;virtual;
           function  GetLength:word;virtual;

           function  GetMemory:longint;virtual;
           function  GetNew:PPol;virtual;
           procedure GetCopy(o:PPol);virtual;
           function  GetNewCopy:PPol;

           function  Equal(o:PPol):boolean;virtual;
           function  NotEqual(o:PPol):boolean;virtual;
           function  Vetsi(o:PPol):boolean;virtual;
           function  Mensi(o:PPol):boolean;virtual;
         end;


  PSym = ^TSym;
  TSym    = object(TPol)

               constructor Init(s:string);
               destructor  Done;virtual;
               procedure   Reset;virtual;

               procedure SetStr(s:PPol);virtual;
               function  GetStr:string;virtual;
               function  GetLength:word;virtual;

               function  GetMemory:longint;virtual;
               function  GetNew:PPol;virtual;
               procedure GetCopy(o:PPol);virtual;

               function  Equal(o:PPol):boolean;virtual;
               function  NotEqual(o:PPol):boolean;virtual;
               function  Vetsi(o:PPol):boolean;virtual;
               function  Mensi(o:PPol):boolean;virtual;
             end;


PHashLink = ^THashLink;
THashLink = record
              s:PSym;
              next:PHashLink;
            end;

PHashTab = ^THashTab;
THashTab = object

             constructor Init;
             destructor Done;virtual;

             function  PtrStr(r:string):PSym;virtual;
             procedure DelStr(r:string);virtual;
             function  Hash(r:string):byte;virtual;
             procedure Vymena(sa,sb:PSym);virtual;

             function  GetMemory:longint;virtual;
             function  GetNew:PHashTab;virtual;
             procedure GetCopy(h:PHashTab);virtual;
             function  GetNewCopy:PHashTab;

           private
             Tab : array [0..MaxHash-1] of PHashLink;
           end;

var HashTab:THashTab;

procedure InitHashTab;
procedure DoneHashTab;
function Sym(r:string):PSym;

implementation

uses Common;



{#########################  Definice metod TPol #########################}

constructor TPol.Init;
begin
  if NotEnoughMemory then Fail;
  Pol:=nil;
end;

destructor  TPol.Done;
begin end;

procedure TPol.Reset;
begin end;

procedure TPol.InitSetStr;
begin end;

procedure TPol.InitGetStr;
begin end;

procedure TPol.SetStr(s:PPol);
begin end;

function  TPol.GetStr:string;
begin
  GetStr:='';
end;

function  TPol.GetLength:word;
begin
  GetLength:=0;
end;

function  TPol.GetMemory:longint;
begin
  GetMemory:=SizeOf(TPol);
end;

function  TPol.GetNew:PPol;
begin
  GetNew:=new(PPol,Init);
end;

procedure TPol.GetCopy(o:PPol);
begin
  if o<>nil then o^.Pol:=Pol;
end;

function  TPol.GetNewCopy:PPol;
var p:PPol;
begin
  p:=GetNew;
  GetCopy(p);
  GetNewCopy:=p;
end;

function  TPol.Equal(o:PPol):boolean;
begin
  Equal:=Pol=o;
end;

function  TPol.NotEqual(o:PPol):boolean;
begin
  NotEqual:=Pol<>o;
end;

function  TPol.Vetsi(o:PPol):boolean;
begin
  Vetsi:=false;
end;

function  TPol.Mensi(o:PPol):boolean;
begin
  Mensi:=false;
end;



{########################  Definice metod TSym  ###########################}

constructor TSym.Init(s:string);
begin
  if not(TPol.Init) then Fail;
  GetMem(Pol,length(s)+1);
  string(Pol^):=s;
end;

destructor  TSym.Done;
begin
  if Pol<>nil then FreeMem(Pol,byte(Pol^)+1);
  TPol.Done;
end;

procedure TSym.Reset;
begin
  if Pol<>nil then FreeMem(Pol,byte(Pol^)+1);
  GetMem(Pol,1);
  string(Pol^):='';
end;

procedure TSym.SetStr(s:PPol);
begin
  if Pol<>nil then FreeMem(Pol,byte(Pol^)+1);
  GetMem(Pol,length(s^.GetStr)+1);
  string(Pol^):=s^.GetStr;
end;

function  TSym.GetStr:string;
begin
  if Pol<>nil then GetStr:=string(Pol^)
  else GetStr:='';
end;

function  TSym.GetLength:word;
begin
  if Pol<>nil then GetLength:=byte(Pol^)
  else GetLength:=0;
end;

function  TSym.GetMemory:longint;
begin
  if Pol<>nil then GetMemory:=SizeOf(TSym)+byte(pol^)+1
  else GetMemory:= SizeOf(TSym);
end;

function  TSym.GetNew:PPol;
begin
  GetNew:=new(PSym,Init(''));
end;

procedure TSym.GetCopy(o:PPol);
begin
  if o<>nil then begin
    with o^ do
      if Pol<>nil then FreeMem(Pol,byte(Pol^)+1);
    GetMem(o^.Pol,byte(Pol^)+1);
    string(o^.Pol^):=string(Pol^);
  end;
end;

function  TSym.Equal(o:PPol):boolean;
begin
  if o<>nil then Equal:=GetStr=o^.GetStr
            else Equal:=false;
end;

function  TSym.NotEqual(o:PPol):boolean;
begin
  if o<>nil then NotEqual:=GetStr<>o^.GetStr
            else NotEqual:=true;
end;

function  TSym.Vetsi(o:PPol):boolean;
begin
  if o<>nil then Vetsi:=GetStr>o^.GetStr
            else Vetsi:=true;
end;

function  TSym.Mensi(o:PPol):boolean;
begin
  if o<>nil then Mensi:=GetStr<o^.GetStr
            else Mensi:=false;
end;



{####################### Metody hashovaci tabulky ########################}

constructor THashTab.Init;
var i:byte;
begin
  if NotEnoughMemory then Fail;
  for i:=0 to MaxHash-1 do Tab[i]:=nil;
end;

destructor THashTab.Done;
var i:byte;
    p,pom:PHashLink;
begin
  for i:=0 to MaxHash-1 do begin
    pom:=Tab[i];
    while pom<>nil do begin
      p:=pom;
      pom:=pom^.next;
      with p^ do
        if s<>nil then dispose(s,Done);
      dispose(p);
    end;
  end;
end;

function  THashTab.PtrStr(r:string):PSym;
var p:PHashLink;
    i:byte;
begin
  i:=Hash(r);
  p:=Tab[i];
  if p=nil then begin
    new(p);
    Tab[i]:=p;
    with p^ do begin
      new(s,Init(r));
      next:=nil;
      PtrStr:=s;
    end;
  end else begin
    while (p^.next<>nil) and (p^.s^.GetStr<>r) do p:=p^.next;
    with p^ do
      if s^.GetStr<>r then begin
        new(next);
        with next^ do begin
          new(s,Init(r));
          next:=nil;
          PtrStr:=s;
        end;
      end else PtrStr:=s;
  end;
end;

procedure THashTab.DelStr(r:string);
var p,q:PHashLink;
    i:byte;
begin
  i:=Hash(r);
  p:=Tab[i];
  if p<>nil then begin
    if p^.s^.GetStr=r then begin
      Tab[i]:=p^.next;
      with p^ do
        if s<>nil then dispose(s,Done);
      dispose(p);
    end else begin
      while (p^.next^.next<>nil) and (p^.next^.s^.GetStr<>r) do p:=p^.next;
      with p^ do
        if next^.s^.GetStr=r then begin
          q:=next;
          next:=q^.next;
          with q^ do
            if s<>nil then dispose(s,Done);
          dispose(q);
        end;
    end;
  end;
end;

function THashTab.Hash(r:string):byte;assembler;
asm
  push ds
  cld
  lds si,r
  lodsb
  mov cl,al
  xor ch,ch
  xor ax,ax
  xor dx,dx
  jcxz @kon
@1:
  lodsb
  add dx,ax
  loop @1
@kon:
  mov ax,dx
  mov bl,MaxHash
  div bl
  mov al,ah
  pop ds
end;

procedure THashTab.Vymena(sa,sb:PSym);
var pa,pb:PHashLink;
    i,j:byte;
    pom:pointer;
begin
  i:=Hash(sa^.GetStr);
  j:=Hash(sb^.GetStr);
  pa:=Tab[i];
  pb:=Tab[j];
  if (pa<>nil) and (pb<>nil) then begin
    while (pa^.next<>nil) and (pa^.s<>sa) do pa:=pa^.next;
    while (pb^.next<>nil) and (pb^.s<>sb) do pb:=pb^.next;
    if (pa^.s=sa) and (pb^.s=sb) then begin
      pa^.s:=sb;pb^.s:=sa;
      pom:=sa^.Pol;sa^.Pol:=sb^.Pol;sb^.Pol:=pom;
    end;
  end;
end;

function  THashTab.GetMemory:longint;
var i:longint;
    j:byte;
    p:PHashLink;
begin
  i:=SizeOf(THashTab);
  for j:=0 to MaxHash-1 do begin
    p:=Tab[j];
    while p<>nil do begin
      i:=i+SizeOf(p^)+p^.s^.GetMemory;
      p:=p^.next;
    end;
  end;
  GetMemory:=i;
end;

function  THashTab.GetNew:PHashTab;
begin
  GetNew:=new(PHashTab,Init);
end;

procedure THashTab.GetCopy(h:PHashTab);
var pom,p:PHashLink;
    i:byte;
begin
  if h<>nil then begin
    for i:=0 to MaxHash-1 do begin
      pom:=Tab[i];
      while pom<>nil do begin
        p:=pom;
        pom:=pom^.next;
        with p^ do
          if s<>nil then dispose(s,Done);
        dispose(p);
      end;
    end;
    for i:=0 to MaxHash-1 do begin
      pom:=Tab[i];
      while pom<>nil do begin
        h^.PtrStr(pom^.s^.GetStr);
        pom:=pom^.next;
      end;
    end;
  end;
end;

function  THashTab.GetNewCopy:PHashTab;
var p:PHashTab;
begin
  p:=GetNew;
  GetCopy(p);
  GetNewCopy:=p;
end;


{######################## Hashovac funkce ############################}

procedure InitHashTab;
begin
  HashTab.Init;
end;

procedure DoneHashTab;
begin
  HashTab.Done;
end;

function  Sym(r:string):PSym;
begin
  Sym:=HashTab.PtrStr(r);
end;

end.