{Ŀ
                                                                         
  Jednotka Tracer - obsahuje objekty vyuzitelne pri krokovani libovolne- 
                    ho algoritmu. Da se vyuzit zejmena pri vyukovych     
                    programech.                                          
                                                                         
 
}

unit Tracer;

interface

{$X+ }

uses Dialogs,Objects,Drivers,Views,Memory,App;

type TAlgText = object(TListBox)
                 constructor Init(var Bounds:TRect);
                 destructor Done;virtual;
                 procedure HandleEvent(var Event:TEvent);virtual;
                 function GetPalette:PPalette;virtual;
                end;
     PAlgText = ^TAlgText;
     TAlgTextCol = object(TCollection)
                    procedure FreeItem(Item:Pointer);virtual;
                    function GetItem(var S:TStream):Pointer;virtual;
                    procedure PutItem(var S:TStream;Item:Pointer);virtual;
                   end;
     PAlgTextCol = ^TAlgTextCol;
     THCollection = object(TCollection)
                      procedure FreeItem(Item:Pointer);virtual;
                    end;
     PHCollection = ^THCollection;
     TAlgWin = object(TWindow)
                 DP        : Pointer;
                 Step      : Word;
                 DS        : Word;
                 SubViewCol: PHCollection;
                 HColCount : Integer;
                 MemOut    : boolean;
                 Down      : boolean;
                 constructor Init(var Bounds:TRect;ATitle:TTitleStr;ANumber:integer;
                                  HCC:word;st:word;DSize:word);
                 constructor Load(var S:TStream);
                 destructor Done;virtual;
                 procedure Store(var S:TStream);virtual;
                 procedure GetData(var Rec);virtual;
                 procedure SetData(var Rec);virtual;
                 function Valid(command:word):boolean;virtual;
                 procedure InsertSubView(pos:Integer;P:PView);
                 function GetSubView(pos:Integer):PView;
                 procedure NS(st:word);
                 procedure NSM(st:word);
                 procedure DoStep(key:word);virtual;
                 procedure UnDoStep;virtual;
                 procedure HandleEvent(var Event:TEvent);virtual;
                 procedure DoProc(start,after:word);
                 procedure Return;
                 procedure ToStep(st,BreakKey:word);virtual;
                 procedure SetState(AState:word;Enable:boolean);virtual;
                 procedure StoreDyn(var S:TStream;p:pointer);virtual;
                 procedure LoadDyn(var S:TStream;p:pointer);virtual;
                 function SaveLocal(var Rec;Sz:word):boolean;
                 procedure SetStatic;
                 procedure DisposeDyn(p:pointer);virtual;
                 procedure CopyDyn(Source,Target:pointer);virtual;
               private
                 DPH       : Pointer;
                 HCol      : PHCollection;
                 Stack     : PHCollection;
                 HStack    : PHCollection;
                 HSCount   : Integer;
                 HColMax   : Integer;
                 Static    : boolean;
                 function GetFrom4(var p;num:byte):byte;
                 procedure InsTo4(var p;num:byte;contents:byte);
                 function SaveStatus(SaveType:byte):boolean;
                 function RestoreStatus:word;virtual;
                 procedure RecoverData;virtual;
                 procedure FromHStackToStack;
                 procedure DisposeData;virtual;
               end;
     PAlgWin = ^TAlgWin;
     TAlgScroller = object(TScroller)
                      DP    : Pointer;
                      Step  : Word;
                      Down  : boolean;
                      First : boolean;
                      constructor Init(var Bounds:TRect;AHScrollBar,AVScrollBar:PScrollBar);
                      constructor Load(var S:TStream);
                      procedure HandleEvent(var Event:TEVent);virtual;
                      procedure Draw;virtual;
                      procedure SetState(AState: Word; Enable: Boolean); virtual;
                      function GetPalette:PPalette;virtual;
                      procedure ChangeBounds(var Bounds:TRect);virtual;
                    end;
     PAlgScroller = ^TAlgScroller;
     ProcPar = record
                 Ad:integer;
                 Dt:pointer;
                 Sz:word
               end;
     PProcPar = ^ProcPar;
const cmChangeFocusedItem = 133;
      cmNewData           = 134;
      cmDoStepF7          = 135;
      cmDoStepF8          = 136;
      cmUnDoStep          = 137;
      cmRunStopAlg        = 138;
      cmSetFirst          = 139;
      cmNewStep           = 140;
      cmNewDown           = 141;

      ssNS                = 0;
      ssNSM               = 1;
      ssDoProc            = 2;
      ssReturn            = 3;

      RAlgText : TStreamRec=(
                 ObjType:107;
                 VMTLink:Ofs(TypeOf(TAlgText)^);
                 Load:@TListBox.Load;
                 Store:@TListBox.Store);
      RAlgTextCol : TStreamRec=(
                    ObjType:108;
                    VMTLink:Ofs(TypeOf(TAlgTextCol)^);
                    Load:@TCollection.Load;
                    Store:@TCollection.Store);
      RAlgWin : TStreamRec=(
                ObjType:109;
                VMTLink:Ofs(TypeOf(TAlgWin)^);
                Load:@TAlgWin.Load;
                Store:@TAlgWin.Store);
      RAlgScroller : TStreamRec=(
                     ObjType:110;
                     VMTLink:Ofs(TypeOf(TalgScroller)^);
                     Load:@TAlgScroller.Load;
                     Store:@TScroller.Store);

implementation
{---------------------- TAlgWin -------------------------------------------}

constructor TAlgWin.Init(var Bounds:TRect;ATitle:TTitleStr;ANumber:integer;
                 HCC:word;st:word;DSize:word);
begin
  TWindow.Init(Bounds,ATitle,ANumber);
  Options:=Options or ofTileable;
  DP:=nil;
  DPH:=nil;
  DS:=DSize;
  HCol:=new(PHCollection,init(3*HCC,10));
  HColMax:=HCC;
  HColCount:=0;
  Step:=st;
  SubViewCol:=new(PHCollection,Init(3,1));
  Stack:=new(PHCollection,Init(10,5));
  HSCount:=0;
  HStack:=new(PHCollection,Init(10,5));
  MemOut:=false;
  Down:=true;
  Static:=false
end;


destructor TAlgWin.Done;
begin
  DisposeData;
  Dispose(HCol,Done);
  Dispose(SubViewCol,Done);
  Dispose(Stack,Done);
  Dispose(HStack,Done);
  TWindow.Done
end;

procedure TAlgWin.GetData(var Rec);
begin
  DisposeDyn(@Rec);
  move(DP^,Rec,DS);
  CopyDyn(DP,@Rec)
end;

procedure TAlgWin.SetData(var Rec);
begin
  GetMem(DP,DS);
  GetMem(DPH,DS);
  move(Rec,DP^,DS);
  move(Rec,DPH^,DS);
  CopyDyn(@Rec,DP);
  CopyDyn(@Rec,DPH);
  if LowMemory then
  begin
    DisposeDyn(DP);
    DisposeDyn(DPH);
    FreeMem(DP,DS);
    FreeMem(DPH,DS);
    DP:=nil;
    DPH:=nil;
    MemOut:=true;
    exit
  end;
  Message(@Self,evBroadcast,cmNewData,DP)
end;

procedure TAlgWin.DisposeData;
var p1,p2:pointer;
begin
  if (DP<>nil)and(DPH<>nil) then begin DisposeDyn(DP);FreeMem(DP,DS) end;
  if DPH<>nil then begin DisposeDyn(DPH);FreeMem(DPH,DS) end;
  if (HCol^.count<>0)and(not Static) then
  begin
    p2:=HCol^.At(HCol^.count-1);
    HCol^.AtDelete(HCol^.count-1);
    repeat
      p1:=p2;
      p2:=HCol^.At(HCol^.count-1);
      HCol^.AtDelete(HCol^.count-1);
      if (p2<>nil)and(p1<>nil) then
      begin
        DisposeDyn(p1);
        FreeMem(p1,DS)
      end
    until HCol^.count=0
  end;
  while HStack^.count>0 do FromHStackToStack;
  if Stack^.count>0 then
  begin
    p2:=Stack^.At(Stack^.count-1);
    Stack^.AtDelete(Stack^.count-1);
    repeat
      p1:=p2;
      p2:=Stack^.At(Stack^.count-1);
      Stack^.AtDelete(Stack^.count-1);
      if (p2<>nil)and(p1<>nil) then
      begin
        FreeMem(PProcPar(p1)^.Dt,PProcPar(p1)^.sz);
        FreeMem(p1,SizeOf(ProcPar))
      end
    until Stack^.count=0
  end;
end;

function TAlgWin.Valid(command:word):boolean;
begin
  Valid:=true;
  if command=cmValid then
  begin
    if MemOut then begin Valid:=false;Application^.OutOfMemory end
  end
end;

procedure TAlgWin.InsertSubView(pos:Integer;p:PView);
begin
  Message(P,evBroadcast,cmNewData,DP);
  Message(P,evBroadcast,cmChangeFocusedItem,Pointer(Step));
  Message(P,evBroadcast,cmNewStep,Pointer(Step));
  SubViewCol^.AtInsert(pos,P);
  Insert(P);
  P^.Draw
end;

function TAlgWin.GetSubView(pos:Integer):PView;
begin
  if (pos>-1)and(pos<SubViewCol^.count) then GetSubView:=PView(SubViewCol^.At(pos))
                                        else GetSubView:=nil
end;

procedure TAlgWin.NS(st:word);
begin
  if not SaveStatus(ssNS) then
  begin
    RecoverData;
    exit
  end;
  ReDraw;
  Step:=st;
  Message(@Self,evBroadcast,cmNewStep,Pointer(Step));
  Message(@Self,evBroadcast,cmChangeFocusedItem,Pointer(Step))
end;

procedure TAlgWin.NSM(st:word);
begin
  if not SaveStatus(ssNSM) then
  begin
    RecoverData;
    exit
  end;
  ReDraw;
  Step:=st;
  Message(@Self,evBroadcast,cmNewStep,Pointer(Step));
  Message(@Self,evBroadcast,cmChangeFocusedItem,Pointer(Step))
end;

procedure TAlgWin.DoStep(key:word);
begin
  Redraw
end;

procedure TAlgWin.UnDoStep;
begin
  Step:=RestoreStatus;
  Message(@Self,evBroadcast,cmNewStep,Pointer(Step));
  ReDraw;
  Message(@Self,evBroadcast,cmChangeFocusedItem,Pointer(Step))
end;

procedure TAlgWin.HandleEvent(var Event:TEvent);
 procedure SendDown;
 begin
   Message(@Self,evBroadcast,cmNewDown,Pointer(Down))
 end;
begin
  TWindow.HandleEvent(Event);
  if (Event.What and evCommand)<>0 then
  begin
    case Event.Command of
      cmDoStepF7: begin Down:=true; SendDown; DoStep(kbF7) end;
      cmDoStepF8: begin Down:=true; SendDown; Dostep(kbF8) end;
      cmUnDoStep: begin Down:=false; SendDown; UnDostep end
    end
  end;
  if (Event.What and evKeyDown)<>0 then
  begin
    case Event.KeyCode of
      kbF7,kbF8 : begin Down:=true; SendDown; DoStep(Event.KeyCode) end;
      kbF9      : begin Down:=false; SendDown; UnDoStep end
    end
  end
end;

procedure TAlgWin.DoProc(Start,After:word);
var p:pointer;
begin
  if not SaveStatus(ssDoProc) then
  begin
    RecoverData;
    exit
  end;
  ReDraw;
  Step:=Start;
  Message(@Self,evBroadcast,cmNewStep,Pointer(Step));
  Message(@Self,evBroadcast,cmChangeFocusedItem,Pointer(Step));
  Stack^.AtInsert(Stack^.count,nil);
  InsTo4(p,1,Hi(After));
  InsTo4(p,2,Lo(After));
  Stack^.AtInsert(Stack^.count,p)
end;

procedure TAlgWin.Return;
var p,p1,p2:pointer;
    HStep:word;
procedure EraseFirst;
begin
  HStack^.AtDelete(0);
  p2:=HStack^.At(0);
  HStack^.AtDelete(0);
  repeat
    p1:=p2;
    p2:=HStack^.At(0);
    if p2<>nil then
    begin
      HStack^.AtDelete(0);
      FreeMem(PProcPar(p1)^.Dt,PProcPar(p1)^.sz);
      FreeMem(p1,SizeOf(ProcPar))
    end
  until p2=nil;
  dec(HSCount);
end;
begin
  if Stack^.count=0 then exit;
  if HSCount > (Round(HColCount/3)+1) then EraseFirst;
  HStack^.AtInsert(HStack^.count,nil);
  p2:=Stack^.At(Stack^.count-1);
  Stack^.AtDelete(Stack^.count-1);
  repeat
    p1:=p2;
    p2:=Stack^.At(Stack^.count-1);
    Stack^.AtDelete(Stack^.count-1);
    if p2=nil then HStep:=256*GetFrom4(p1,1)+GetFrom4(p1,2)
              else
    With PProcPar(p1)^ do
    begin
      p:=Ptr(seg(DP^),ofs(DP^)-Ad);
      move(DT^,p^,Sz)
    end;
    HStack^.AtInsert(HStack^.count,p1)
  until p2=nil;
  if not SaveStatus(ssReturn) then
  begin
    RecoverData;
    FromHStackToStack;
    exit
  end;
  inc(HSCount);
  ReDraw;
  Step:=HStep;
  Message(@Self,evBroadcast,cmNewStep,Pointer(Step));
  Message(@Self,evBroadcast,cmChangeFocusedItem,Pointer(Step))
end;


procedure TAlgWin.InsTo4(var p;num:byte;contents:byte);
begin
  move(contents,mem[seg(p):ofs(p)+num],1)
end;

function TAlgWin.GetFrom4(var p;num:byte):byte;
var c:byte;
begin
  move(mem[seg(p):ofs(p)+num],c,1);
  GetFrom4:=c
end;

function TAlgWin.SaveStatus(SaveType:byte):boolean;
var p:pointer;
    i:word;
procedure EraseFirst;
begin
  HCol^.AtDelete(0);
  HCol^.AtDelete(0);
  repeat
    if HCol^.count>0 then p:=HCol^.At(0) else p:=nil;
    if p<>nil then
    begin
      if not Static then begin DisposeDyn(p);FreeMem(p,DS) end;
      HCol^.AtDelete(0)
    end 
  until p=nil;
  dec(HColCount)
end;
begin
  SaveStatus:=true;
  if HColMax=0 then exit;
  if HColCount>=HColMax then EraseFirst;
  HCol^.AtInsert(HCol^.count,nil);
  InsTo4(p,0,SaveType);
  InsTo4(p,1,Hi(Step));
  InsTo4(p,2,Lo(Step));
  HCol^.AtInsert(HCol^.count,p);
  inc(HColCount);
  if SaveType>ssNS then
  begin
    if Static then
    begin
      i:=0;
      while i<DS do
      begin
        if mem[seg(DPH^):ofs(DPH^)+i]<>mem[seg(DP^):ofs(DP^)+i] then
        begin
          InsTo4(p,1,Hi(i));
          InsTo4(p,2,Lo(i));
          InsTo4(p,3,mem[seg(DPH^):ofs(DPH^)+i]);
          mem[Seg(DPH^):ofs(DPH^)+i]:=mem[seg(DP^):ofs(DP^)+i];
          HCol^.AtInsert(HCol^.count,p)
        end;
        inc(i)
      end
    end
             else
    begin
      GetMem(p,DS);
      move(DPH^,p^,DS);
      CopyDyn(DPH,p);
      if LowMemory then
      begin
        Application^.OutOfMemory;DisposeDyn(p);FreeMem(p,DS);
        SaveStatus:=false;exit
      end;
      DisposeDyn(DPH);
      move(DP^,DPH^,DS);
      CopyDyn(DP,DPH);
      if LowMemory then
      begin
        Application^.OutOfMemory;DisposeDyn(DPH);move(p^,DPH^,DS);
        CopyDyn(p,DPH);DisposeDyn(p);FreeMem(p,DS);SaveStatus:=false;exit
      end;
      HCol^.AtInsert(HCol^.count,p)
    end
  end
end;

function TAlgWin.RestoreStatus:word;
var p1,p2:pointer;
    i:word;
procedure EraseLast;
var q,q1,q2:pointer;
begin
  if Stack^.count=0 then exit;
  q2:=Stack^.At(Stack^.count-1);
  Stack^.AtDelete(Stack^.count-1);
  repeat
    q1:=q2;
    q2:=Stack^.At(Stack^.count-1);
    Stack^.AtDelete(Stack^.count-1);
    if q2<>nil then
    begin
      FreeMem(PProcPar(q1)^.Dt,PProcPar(q1)^.sz);
      FreeMem(q1,SizeOf(ProcPar))
    end;
  until q2=nil
end;
begin
  RestoreStatus:=Step;
  if HColCount=0 then exit;
  DisposeDyn(DP);
  move(DPH^,DP^,DS);
  CopyDyn(DPH,DP);
  p2:=HCol^.At(HCol^.count-1);
  HCol^.AtDelete(HCol^.count-1);
  repeat
    p1:=p2;
    p2:=HCol^.At(Hcol^.count-1);
    HCol^.AtDelete(HCol^.count-1);
    i:=256*GetFrom4(p1,1)+GetFrom4(p1,2);
    if p2=nil then
    begin
      RestoreStatus:=i;
      if GetFrom4(p1,0)=ssDoProc then EraseLast;
      if GetFrom4(p1,0)=ssReturn then FromHStackToStack;
    end
              else
    begin
      if Static then
      begin
        mem[seg(DP^):ofs(DP^)+i]:=GetFrom4(p1,3);
        mem[seg(DPH^):ofs(DPH^)+i]:=GetFrom4(p1,3)
      end
                else
      begin
        DisposeDyn(DP);
        DisposeDyn(DPH);
        move(p1^,DP^,DS);
        move(p1^,DPH^,DS);
        CopyDyn(p1,DPH);
        DisposeDyn(p1);
        FreeMem(p1,DS);
        CopyDyn(DPH,DP)
      end
    end
  until p2=nil;
  dec(HColCount)
end;

function TAlgWin.SaveLocal(var Rec;Sz:word):boolean;
var p:PProcPar;
begin
  GetMem(p,SizeOf(ProcPar));
  GetMem(p^.Dt,Sz);
  if LowMemory then
  begin
    Application^.OutOfMemory;
    FreeMem(p^.Dt,Sz);
    FreeMem(P,SizeOf(ProcPar));
    SaveLocal:=false;
    exit
  end;
  move(Rec,p^.Dt^,Sz);
  p^.Sz:=Sz;
  P^.Ad:=ofs(DP^)-ofs(Rec);
  Stack^.AtInsert(Stack^.count,p);
  SaveLocal:=True
end;

procedure TAlgWin.SetStatic;
begin
  Static:=true
end;

procedure TAlgWin.DisposeDyn;
begin
end;

procedure TAlgWin.CopyDyn;
begin
end;

procedure TAlgWin.RecoverData;
begin
  HCol^.AtDelete(HCol^.count-1);
  HCol^.AtDelete(HCol^.count-1);
  DisposeDyn(DP);
  move(DPH^,DP^,DS);
  CopyDyn(DPH,DP)
end;


procedure TAlgWin.FromHStackToStack;
var p:pointer;
begin
  Stack^.AtInsert(Stack^.count,nil);
  repeat
    p:=HStack^.At(HStack^.count-1);
    HStack^.AtDelete(HStack^.count-1);
    if p<>nil then Stack^.AtInsert(Stack^.count,p)
  until p=nil;
  dec(HSCount)
end;

procedure TAlgWin.ToStep(st,BreakKey:word);
var Event:TEvent;
begin
  Down:=true;
  Message(@Self,evBroadcast,cmNewDown,Pointer(Down));
  repeat
    DoStep(kbF8);
    if EventAvail then GetEvent(Event);
  until (Step=st)or(Event.Command=cmRunStopAlg)or((Event.KeyCode=BreakKey)and(BreakKey<>kbNoKey))
end;

procedure TAlgWin.SetState(AState:word;Enable:boolean);
begin
  if (AState and (sfVisible or sfExposed))<>0 then Message(@Self,evBroadcast,cmSetFirst,@Self);
  TWindow.SetState(AState,Enable)
end;

procedure TAlgWin.StoreDyn(var S:TStream;p:pointer);
begin
end;

procedure TAlgwin.LoadDyn(var S:TStream;p:pointer);
begin
end;

procedure TAlgWin.Store(var S:TStream);
var c:byte;
    i:integer;
    q:pointer;
procedure WriteDP(p:pointer);
begin
  if p=nil then begin c:=0; s.write(C,1) end
           else
  begin
    c:=1;
    S.write(c,1);
    S.write(P^,DS);
    StoreDyn(S,p)
  end
end;
begin
  TWindow.Store(S);
  S.write(DS,2);
  S.write(HSCount,2);
  S.write(HColMax,2);
  S.write(HColCount,2);
  S.write(Step,2);
  S.write(MemOut,1);
  S.write(Down,1);
  S.write(Static,1);
  WriteDP(DP);
  WriteDP(DPH);
  S.write(HCol^.count,2);
  i:=0;
  while i<HCol^.count do
  begin
    q:=HCol^.At(i);inc(i);
    if static then S.write(q,4)
              else
    begin
      if q=nil then
      begin
        c:=0;S.write(c,1);q:=HCol^.At(i);inc(i);S.write(q,4)
      end
               else
      begin
        c:=1;s.write(c,1);s.write(q^,DS);StoreDyn(S,q)
      end
    end
  end;
  S.write(SubViewCol^.count,2);
  i:=0;
  while i<SubViewCol^.count do
  begin
    PutSubViewPtr(S,SubViewCol^.At(i));
    inc(i)
  end;
  S.write(Stack^.count,2);
  i:=0;
  while i<Stack^.count do
  begin
    q:=Stack^.At(i);inc(i);
    if q=nil then
    begin
      c:=0;S.write(c,1);q:=Stack^.At(i);S.write(q,4);inc(i)
    end
             else
    begin
      c:=1;S.write(c,1);
      with PProcPar(q)^ do
      begin
        S.write(Ad,2);S.write(Sz,2);S.write(Dt^,Sz)
      end
    end
  end;
  S.write(HStack^.count,2);
  i:=0;
  while i<HStack^.count do
  begin
    q:=HStack^.At(i);inc(i);
    if q=nil then begin c:=0;S.write(c,1);S.write(q,4) end
             else
    begin
      if (i=HStack^.count)or(HStack^.At(i)=nil) then
      begin
        c:=0;S.write(c,1);
        S.write(q,4)
      end
                                                    else
      begin
        c:=1;S.write(c,1);
        with PProcPar(q)^ do
        begin
          S.write(Ad,2);S.write(Sz,2); S.write(Dt^,Sz)
        end
      end
    end
  end
end;

constructor TAlgWin.Load(var S:TStream);
var c:byte;
    i:integer;
    q:pointer;
procedure ReadDP(var p:pointer);
begin
  S.read(c,1);
  if c=0 then p:=nil
         else
  begin
    GetMem(p,DS);
    S.read(p^,DS);
    LoadDyn(S,p)
  end
end;
begin
  TWindow.Load(S);
  S.read(DS,2);
  S.read(HSCount,2);
  S.read(HColMax,2);
  S.read(HColCount,2);
  S.read(Step,2);
  S.read(MemOut,1);
  S.read(Down,1);
  S.read(Static,1);
  ReadDP(DP);
  ReadDP(DPH);
  Message(@Self,evBroadcast,cmNewData,DP);
  Message(@Self,evBroadcast,cmNewStep,Pointer(Step));
  Message(@Self,evBroadcast,cmNewDown,Pointer(Down));
  S.read(i,2);
  HCol:=new(PHCollection,Init(3*HColMax,10));
  while HCol^.Count<i do
  begin
    if static then begin S.read(q,4);HCol^.AtInsert(HCol^.count,q) end
              else
    begin
      S.read(c,1);
      if c=0 then begin S.read(q,4);HCol^.AtInsert(HCol^.count,nil);HCol^.AtInsert(HCol^.count,q) end
             else
      begin
        GetMem(q,DS);
        S.read(q^,DS);
        LoadDyn(S,q);
        HCol^.AtInsert(HCol^.count,q)
      end
    end
  end;
  S.read(i,2);
  SubViewCol:=new(PHCollection,Init(3,1));
  while SubViewCol^.count<i do
  begin
    GetSubViewPtr(S,q);
    SubViewCol^.AtInsert(SubViewCol^.count,q)
  end;
  S.read(i,2);
  Stack:=new(PHCollection,Init(10,5));
  while Stack^.count<i do
  begin
    S.read(c,1);
    if c=0 then begin Stack^.AtInsert(Stack^.count,nil);S.read(q,4);Stack^.AtInsert(Stack^.count,q) end
           else
    begin
      GetMem(q,SizeOf(ProcPar));
      with PProcPar(q)^ do
      begin
        S.read(Ad,2);
        S.read(Sz,2);
        GetMem(Dt,Sz);
        S.read(Dt^,Sz)
      end;
      Stack^.AtInsert(Stack^.count,q)
    end
  end;
  S.read(i,2);
  HStack:=new(PHCollection,Init(10,5));
  while HStack^.count<i do
  begin
    S.read(c,1);
    if c=0 then begin S.read(q,4); HStack^.AtInsert(HStack^.count,q) end
           else
    begin
      GetMem(q,SizeOf(ProcPar));
      with PProcPar(q)^ do
      begin
        S.read(Ad,2);
        S.read(Sz,2);
        GetMem(Dt,Sz);
        S.read(Dt^,Sz)
      end;
      HStack^.AtInsert(HStack^.count,q)
    end
  end;
  MemOut:=LowMemory
end;

{---------------------- TAlgScroller --------------------------------------}

constructor TAlgScroller.Init(var Bounds:TRect;AHScrollBar,AVScrollBar:PScrollBar);
begin
  TScroller.Init(Bounds,AHScrollBar,AVScrollBar);
  DP:=nil;
  EventMask:=$0300;
  Options:=Options and (not ofSelectable);
  First:=true
end;

procedure TAlgScroller.HandleEvent(var Event:TEvent);
begin
  if (Event.What and evBroadCast)<>0 then
  begin
    case Event.Command of
      cmNewData : begin
                    DP:=Event.InfoPtr;
                    First:=true;
                    Draw
                  end;
      cmNewStep : Step:=Word(Event.InfoPtr);
      cmNewDown : Down:=boolean(Event.InfoPtr);
      cmSetFirst : First:=true
    end
  end;
  TScroller.HandleEvent(Event)
end;

procedure TAlgScroller.Draw;
var y:byte;
    Buf:TDrawBuffer;
begin
  if first then
  begin
    MoveChar(Buf,' ',GetColor(1),Size.x);
    First:=false;
    for y:=0 to size.y do WriteLine(0,y,Size.x,1,Buf)
  end
end;

procedure TAlgScroller.SetState(AState: Word; Enable: Boolean);
begin
  TScroller.SetState(AState,Enable);
  if (AState and (sfVisible or sfExposed))<>0 then First:=true
end;


function TAlgScroller.GetPalette:PPalette;
const P:string[3]=#6#7#2;
begin
  GetPalette:=@P
end;

procedure TAlgScroller.ChangeBounds(var Bounds:TRect);
begin
  TScroller.ChangeBounds(Bounds);
  First:=true;
  Draw
end;

constructor TAlgScroller.Load(var S:TStream);
begin
  TScroller.Load(S);
  First:=true
end;

{---------------------- THCollection --------------------------------------}

procedure THCollection.FreeItem(Item:Pointer);
begin
end;

{---------------------- TAlgText ------------------------------------------}

constructor TAlgText.Init(var Bounds:TRect);
begin
  TListBox.Init(Bounds,1,nil);
  EventMask:=$0300 or evKeyDown;
  Options:=Options and (not ofSelectable) or ofPostProcess
end;

destructor TAlgText.Done;
begin
  if List<>nil then Dispose(List,Done);
  TListBox.Done
end;


procedure TAlgText.HandleEvent(var Event:TEvent);
begin
  if ((Event.What and evKeyDown)<>0)and(Owner^.Phase=phPostProcess) then
  begin
    case Event.KeyCode of
      kbUp:if TopItem>0 then dec(TopItem);
      kbDown:if (TopItem+Size.y)<List^.count then inc(TopItem);
      kbPgUp:if (TopItem-Size.y)>0 then TopItem:=TopItem-Size.y
                                   else TopItem:=0;
      kbPgDn:if (TopItem+2*Size.y)<List^.count then TopItem:=TopItem+Size.y
                                               else
             begin
               if (List^.count-Size.y)>0 then TopItem:=List^.count-Size.y
                                         else TopItem:=0
             end;
      kbCtrlPgUp:TopItem:=0;
      kbCtrlPgDn:if (List^.count-Size.y)>0 then TopItem:=List^.Count-Size.y
                                           else TopItem:=0
    end;
    Draw;
    exit
  end;
  TListBox.HandleEvent(Event);
  if (Event.What and evBroadcast)<>0 then
     case Event.Command of
       cmChangeFocusedItem: begin FocusItem(Word(Event.InfoPtr));Draw end
     end
end;

function TAlgText.GetPalette:PPalette;
const P:string[5]=#3#3#4#4#1;
begin
  GetPalette:=@P
end;

{--------------------- TAlgTextCol ---------------------------------------}

procedure TAlgTextCol.FreeItem(Item:Pointer);
begin
  DisposeStr(PString(At(IndexOf(Item))))
end;

function TAlgTextCol.GetItem(var S:TStream):Pointer;
begin
  GetItem:=S.ReadStr
end;

procedure TAlgTextCol.PutItem(var S:TStream;Item:Pointer);
begin
  S.WriteStr(PString(Item))
end;

{-------------------- inicializacni cast ----------------------------------}
begin
  RegisterType(RAlgText);
  RegisterType(RAlgTextCol);
  RegisterType(RAlgWin);
  RegisterType(RAlgScroller)
end.
